Summary:	A utility for unpacking zip files
Name:		unzip
Epoch:		1
Version:	6.0
Release:	%mkrel 8
License:	BSD
Group:		Archiving/Compression
URL:		http://www.info-zip.org/UnZip.html
Source0:	https://downloads.sourceforge.net/infozip/unzip60.tar.gz
# Not sent to upstream.
Patch1: unzip-6.0-bzip2-configure.patch
# Upstream plans to do this in zip (hopefully also in unzip).
Patch2: unzip-6.0-exec-shield.patch
# Upstream plans to do similar thing.
Patch3: unzip-6.0-close.patch
# Details in rhbz#532380.
# Reported to upstream: http://www.info-zip.org/board/board.pl?m-1259575993/
Patch4: unzip-6.0-attribs-overflow.patch
# Not sent to upstream, as it's Fedora/RHEL specific.
# Modify the configure script to accept var LFLAGS2 so linking can be configurable
# from the spec file. In addition '-s' is still removed as before
Patch5: unzip-6.0-configure.patch
Patch6: unzip-6.0-manpage-fix.patch
# Update match.c with recmatch() from zip 3.0's util.c
# This also resolves the license issue in that old function.
# Original came from here: https://projects.parabolagnulinux.org/abslibre.git/plain/libre/unzip-libre/match.patch
Patch7: unzip-6.0-fix-recmatch.patch
# Update process.c
Patch8: unzip-6.0-symlink.patch
# change using of macro "case_map" by "to_up"
Patch9: unzip-6.0-caseinsensitive.patch
# downstream fix for "-Werror=format-security"
# upstream doesn't want hear about this option again
Patch10: unzip-6.0-format-secure.patch

Patch11: unzip-6.0-valgrind.patch
Patch12: unzip-6.0-x-option.patch
Patch13: unzip-6.0-overflow.patch
Patch14: unzip-6.0-cve-2014-8139.patch
Patch15: unzip-6.0-cve-2014-8140.patch
Patch16: unzip-6.0-cve-2014-8141.patch
Patch17: unzip-6.0-overflow-long-fsize.patch

# Fix heap overflow and infinite loop when invalid input is given (#1260947)
Patch18: unzip-6.0-heap-overflow-infloop.patch

# support non-{latin,unicode} encoding
Patch19: unzip-6.0-alt-iconv-utf8.patch
Patch20: unzip-6.0-alt-iconv-utf8-print.patch
Patch21: 0001-Fix-CVE-2016-9844-rhbz-1404283.patch

# restore unix timestamp accurately
Patch22: unzip-6.0-timestamp.patch

# fix possible heap based stack overflow in passwd protected files
Patch23: unzip-6.0-cve-2018-1000035-heap-based-overflow.patch

Patch24: unzip-6.0-cve-2018-18384.patch

# covscan issues
Patch25: unzip-6.0-COVSCAN-fix-unterminated-string.patch

Patch26: unzip-zipbomb-part1.patch
Patch27: unzip-zipbomb-part2.patch
Patch28: unzip-zipbomb-part3.patch
Patch29: unzip-zipbomb-manpage.patch
Patch30: unzip-zipbomb-part4.patch
Patch31: unzip-zipbomb-part5.patch
Patch32: unzip-zipbomb-part6.patch
Patch33: unzip-zipbomb-switch.patch
Patch34: unzip-gnu89-build.patch
Patch35: unzip-6.0-wcstombs-fortify.patch

Patch40:	CVE-2021-4217.patch
Patch41:	CVE-2022-0529.patch
Patch42:	CVE-2022-0530.patch

Patch43:    unzip-6.0-mga-egrep.patch

BuildRequires:	bzip2-devel, gcc

%description
The unzip utility is used to list, test, or extract files from a zip
archive.  Zip archives are commonly found on MS-DOS systems.  The zip
utility, included in the zip package, creates zip archives.  Zip and
unzip are both compatible with archives created by PKWARE(R)'s PKZIP
for MS-DOS, but the programs' options and default behaviors do differ
in some respects.

Install the unzip package if you need to list, test or extract files from
a zip archive.

%prep
%autosetup -n unzip60 -p1

%build
# (tv) link with libbz2 thus fixing "need PK compat. v4.5 (can do v2.1)" when eg building perl-Archive-Zip:
perl -pi -e 's!(LIB_BZ\s+=)!\1 -lbz2!' unix/Makefile
perl -pi -e 's!(LF2\s+=)!\1 -lbz2!' unix/Makefile

# IZ_HAVE_UXUIDGID is needed for right functionality of unzip -X
# NOMEMCPY solve problem with memory overlapping - decompression is slowly,
# but successfull.
LOCAL_UNZIP="%{optflags} -I." %make_build -f unix/Makefile CF_NOOPT="-I. -DUNIX $RPM_OPT_FLAGS -DNOMEMCPY -DIZ_HAVE_UXUIDGID -DNO_LCHMOD -D_FILE_OFFSET_BITS=64 -DACORN_FTYPE_NFS -DWILD_STOP_AT_DIR -DLARGE_FILE_SUPPORT -DUNICODE_SUPPORT -DUNICODE_WCHAR -DUTF8_MAYBE_NATIVE -DNO_LCHMOD -DDATE_FORMAT=DF_YMD -DNATIVE -I. -DHAVE_LOCALE_H -DICONV_MAPPING -DBZIP2_SUPPORT -lbz2" \
                      LFLAGS2="%{?__global_ldflags}" generic_gcc

%install
rm -rf $RPM_BUILD_ROOT
make -f unix/Makefile prefix=%{buildroot}%{_prefix} MANDIR=%{buildroot}%{_mandir}/man1 INSTALL="cp -p" install

%files
%license LICENSE COPYING.OLD
%doc README BUGS
%{_bindir}/*
%{_mandir}/man1/*


%changelog
* Sun Jun 29 2025 umeabot <umeabot> 1:6.0-8.mga10
+ Revision: 2222194
- Mageia 10 Mass Rebuild

* Fri Apr 19 2024 danf <danf> 1:6.0-7.mga10
+ Revision: 2059796
- Silence "egrep is obsolescent" from zipgrep

* Sat Apr 06 2024 wally <wally> 1:6.0-6.mga10
+ Revision: 2055091
- sync patches with Fedora

* Sat Apr 06 2024 wally <wally> 1:6.0-5.mga10
+ Revision: 2055087
- add Fedora patch to build using gnu89

* Fri Oct 14 2022 ns80 <ns80> 1:6.0-4.mga9
+ Revision: 1896791
- backport patches from Ubuntu for CVE-2021-4217, CVE-2022-0529, CVE-2022-0530 (mga#29893)

* Fri Mar 18 2022 umeabot <umeabot> 1:6.0-3.mga9
+ Revision: 1797843
- Mageia 9 Mass Rebuild

* Wed Jan 13 2021 neoclust <neoclust> 1:6.0-2.mga8
+ Revision: 1671663
- Define LOCAL_UNZIP

* Tue Jan 12 2021 neoclust <neoclust> 1:6.0-1.mga8
+ Revision: 1671456
- Switch back to official unzip release + patches for CVE + zipbomb

* Tue Feb 18 2020 umeabot <umeabot> 6.1c-8.mga8
+ Revision: 1539072
- Mageia 8 Mass Rebuild

* Fri Nov 29 2019 ns80 <ns80> 6.1c-7.mga8
+ Revision: 1463763
- modify the options of compilation to solve the wrong encoding in zip archives created in Windows (mga#25052)

* Fri Sep 27 2019 tv <tv> 6.1c-6.mga8
+ Revision: 1446714
- link with libbz2 thus fixing "need PK compat. v4.5 (can do v2.1)" when eg
  building perl-Archive-Zip
- switch back the sources to the zip archive
- add a minimal test:
  verify the newly built unzip is able to check its own sources

* Wed Aug 07 2019 shlomif <shlomif> 6.1c-5.mga8
+ Revision: 1427993
- Disable the patch for now due to false positives.
  Temporarily converted the .zip to tar.xz using 7z and tar.

* Mon Aug 05 2019 shlomif <shlomif> 6.1c-4.mga8
+ Revision: 1427394
- tentative fix for MGA#25076.
  Tested to be fine rudimentarily.

* Fri Apr 05 2019 tv <tv> 6.1c-3.mga7
+ Revision: 1385972
- update from 610c23 to 610c25

* Sat Oct 20 2018 bcornec <bcornec> 6.1c-2.mga7
+ Revision: 1323065
- Disable LZMA support

* Sat Oct 20 2018 bcornec <bcornec> 6.1c-1.mga7
+ Revision: 1323057
- This version is tagged 6.1c in the upstream README so adapting

* Sat Oct 13 2018 bcornec <bcornec> 6.0-22.mga7
+ Revision: 1319952
+ rebuild (emptylog)

* Sat Oct 13 2018 bcornec <bcornec> 6.0-21.mga7
+ Revision: 1319950
- Rebuild with LOCAL_UNZIP declared

* Sun Sep 23 2018 umeabot <umeabot> 6.0-20.mga7
+ Revision: 1301534
- Mageia 7 Mass Rebuild

* Sun Feb 11 2018 shlomif <shlomif> 6.0-19.mga7
+ Revision: 1200533
- Upgrade to new version - fix MGA#22571 .

* Wed Dec 20 2017 shlomif <shlomif> 6.0-18.mga7
+ Revision: 1183619
- Fixed patch from fedora that fixes CPAN#106089 .

* Fri Jan 06 2017 mrambo3501 <mrambo3501> 6.0-17.mga6
+ Revision: 1080323
- added debian patches fixing CVE-2014-9913 and CVE-2016-9844
- cleaned up the existing libnatspec patch

* Wed Feb 17 2016 umeabot <umeabot> 6.0-16.mga6
+ Revision: 963176
- Mageia 6 Mass Rebuild

* Tue Nov 10 2015 luigiwalser <luigiwalser> 6.0-15.mga6
+ Revision: 901016
- update patch5 with fix for rhbz#1260944 with regression fix from ubuntu

* Wed Sep 23 2015 luigiwalser <luigiwalser> 6.0-14.mga6
+ Revision: 882494
- add patch from fedora to fix heap overflow and infinite loop (rhbz#1260947)

* Wed Feb 11 2015 luigiwalser <luigiwalser> 6.0-13.mga5
+ Revision: 814647
- use improved patch from mancha for CVE-2014-9636

* Fri Dec 26 2014 luigiwalser <luigiwalser> 6.0-12.mga5
+ Revision: 806263
- rediff patch from mancha to fix oob accesses in test_compr_br (CVE-2014-9636)

* Mon Dec 22 2014 luigiwalser <luigiwalser> 6.0-11.mga5
+ Revision: 804927
- add patches from redhat to fix CVE-2014-8139, CVE-2014-8140, and CVE-2014-8141

* Wed Oct 15 2014 umeabot <umeabot> 6.0-10.mga5
+ Revision: 750990
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 6.0-9.mga5
+ Revision: 690064
- Mageia 5 Mass Rebuild

* Tue Mar 18 2014 alexl <alexl> 6.0-8.mga5
+ Revision: 604849
- clean spec
- add non-latin support (mga#10134)

* Fri Oct 18 2013 umeabot <umeabot> 6.0-7.mga4
+ Revision: 519909
- Mageia 4 Mass Rebuild

* Mon Jan 14 2013 umeabot <umeabot> 6.0-6.mga3
+ Revision: 385077
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jun 29 2012 solbu <solbu> 6.0-5.mga3
+ Revision: 264896
- Dont ship useless INSTALL file

* Sat Jan 08 2011 blino <blino> 6.0-4.mga1
+ Revision: 535
- use product macros in patent advisory
- imported package unzip


* Sat Dec 04 2010 Oden Eriksson <oeriksson@mandriva.com> 6.0-3mdv2011.0
+ Revision: 608114
- rebuild

* Sun Mar 14 2010 Oden Eriksson <oeriksson@mandriva.com> 6.0-2mdv2010.1
+ Revision: 519078
- rebuild

* Mon Jul 27 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 6.0-1mdv2010.0
+ Revision: 401038
- update to new version 6.0
- enable LZW compression methods, since 2003 the patents are expired
- drop all patches
- spec file clean

* Sat Apr 11 2009 Funda Wang <fwang@mandriva.org> 5.52-8mdv2009.1
+ Revision: 366432
- disable formatchecking under all archs
- disable format checking
- reidff 64 bit patch

  + Antoine Ginies <aginies@mandriva.com>
    - rebuild

* Wed Jun 18 2008 Thierry Vignaud <tv@mandriva.org> 5.52-6mdv2009.0
+ Revision: 225903
- rebuild

* Tue Mar 18 2008 Oden Eriksson <oeriksson@mandriva.com> 5.52-5mdv2008.1
+ Revision: 188613
- fix #39030 (CVE-2008-0888: unzip - DoS and/or arbitrary code execution due to NEEDBITS macro)

* Mon Feb 25 2008 Olivier Blin <oblin@mandriva.com> 5.52-4mdv2008.1
+ Revision: 174813
- build with _FILE_OFFSET_BITS=64 (#37178)
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Sep 16 2007 Thierry Vignaud <tv@mandriva.org> 5.52-3mdv2008.0
+ Revision: 87711
- kill changelog left by repsys


* Tue Jan 30 2007 Götz Waschk <waschk@mandriva.org> 5.52-2mdv2007.0
+ Revision: 115447
- Import unzip

* Tue Jan 30 2007 Götz Waschk <waschk@mandriva.org> 5.52-2mdv2007.1
- unpack patches

* Thu Mar 16 2006 Olivier Blin <oblin@mandriva.com> 5.52-2mdk
- from Stew Benedict: security update for CAN-2005-2475 (P2)
- from Vincent Danen: security fix for CVE-2005-4667 (P3)

* Thu May 05 2005 Götz Waschk <waschk@mandriva.org> 5.52-1mdk
- drop patch 0 and define LZW_CLEAN instead
- better source URL
- New release 5.52

* Mon May 31 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.51-1mdk
- fixes multiple vulnerabilities

